Attribute VB_Name = "mLSAPI"
Option Explicit

'*********************************************************************************
'*
'*      Imports from wharfdata.h and lsapi.h to include in visual basic
'*      Author: James Elkins
'*      Email: jelkins@dhcp-58-70.adacpe.cableone.net
'*      URL: http://dhcp-58-70.adacpe.cableone.net/vbmodulo/
'*      Copyright 2000 James Elkins, All Rights Reserved
'*
'*      You are free to use this code within your own applications, but you
'*      are expressly forbidden from selling or otherwise distributing this
'*      source code without prior written consent.
'*
'*      NOTE:
'*          Before using this read the readme.txt file and other documents,
'*          they contain important information on how to make a lite step
'*          modulo.
'*
'*
'*      This bas file includes Const declares and api's for useing the lsapi.dll
'*      I had to make a dll wrapper for the lsapi.dll because of the exports of the
'*      lsapi.dll where not directly callable from vb. The dll wrapper will continue
'*      to work as long as the function params and function names of the lsapi.dll
'*      stay the same. So it is safe to update the lsapi.dll when you update LiteStep.
'*      If you find any bugs or problems email them to me and I will try and fix them.
'*
'*********************************************************************************

Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type


'***************************************
'*  Begin wharfdata.h
Public Type windowType
    Handle As Long
    Visible As Boolean
    'Position As rect
    Desk As Long
End Type

Public Type wharfDataType
    borderSize As Long
    pos As Long
    winListSize As Long
    winList As windowType
    trayIconSize As Long
    lm78Unit As Long
    lm78MaxCpu As Long
    lm78Cpu As Integer
    taskBar As Long
    msTaskBar As Long
    taskBarFore As Long
    taskBarBack As Long
    taskBarText As Long
    vwmVelocity As Long
    autoHideWharf As Long
    autoHideTaskbar As Long
    VWMDistance As Long
    autoHideDelay As Long
    showBeta As Long
    usClock As Long
    VWMNoGathering As Long
    VWMNoAuto As Long
    xmouseDelay As Long
    xmouseBringToTop As Long
    pixmapDir As String
    defaultBmp As String
    vwmBackColor As Long
    vwmSelBackColor As Long
    vwmForeColor As Long
    vwmBorderColor As Long
    backsaver As String
    taskBarFore2 As Long
    stripBar As Long
    lsPath As String
End Type

Public Const magicDWord = &H49474541

'*  End wharfdata.h
'***************************************

'***************************************
'*  Begin lsapi.h
'//---------------------------------------------------------
'// Defines
'//---------------------------------------------------------

'/* match defines */
Public Const MATCH_PATTERN = 6    '/* bad pattern */
Public Const MATCH_LITERAL = 5    '/* match failure on literal match */
Public Const MATCH_RANGE = 4      '/* match failure on [..] construct */
Public Const MATCH_ABORT = 3      '/* premature end of text string */
Public Const MATCH_END = 2        '/* premature end of pattern string */
Public Const MATCH_VALID = 1      '/* valid match */

'/* pattern defines */
Public Const PATTERN_VALID = 0    '/* valid pattern */
Public Const PATTERN_ESC = -1     '/* literal escape at end of pattern */
Public Const PATTERN_RANGE = -2   '/* malformed range in [..] construct */
Public Const PATTERN_CLOSE = -3   '/* no end bracket in [..] construct */
Public Const PATTERN_EMPTY = -4   '/* [..] contstruct is empty */

'/* message defines */
Public Const LM_SHUTDOWN = 8889
Public Const LM_REPAINT = 8890
Public Const LM_BRINGTOFRONT = 8891
Public Const LM_SAVEDATA = 8892
Public Const LM_RESTOREDATA = 8893
Public Const LM_POPUP = 9182
Public Const LM_HIDEPOPUP = 9183
Public Const LM_FIRSTDESKTOPPAINT = 9184
Public Const LM_LSSELECT = 9185
Public Const LM_SETTASKBARONTOP = 9186
Public Const LM_SAVESYSTRAY = 9210
Public Const LM_RESTORESYSTRAY = 9211
Public Const LM_CHECKFORAPPBAR = 9212
Public Const LM_SENDSYSTRAY = 9213
Public Const LM_SYSTRAY = 9214
'// Shell Hook Messages (obsolete!)
Public Const LM_SHELLMESSAGE = 9219
Public Const LM_ACCESSSTATE = 9220
Public Const LM_ACTIVESHELLWIN = LM_ACCESSSTATE + 1
Public Const LM_APPCOMMANDX = LM_ACCESSSTATE + 2
Public Const LM_MINMAXWIN = LM_ACCESSSTATE + 3
Public Const LM_LANGUAGEX = LM_ACCESSSTATE + 4
Public Const LM_REDRAWX = LM_ACCESSSTATE + 5
Public Const LM_TASKMANX = LM_ACCESSSTATE + 6
Public Const LM_ACTIVEWIN = LM_ACCESSSTATE + 7
Public Const LM_ADDWINDOW = LM_ACCESSSTATE + 8
Public Const LM_REMOVEWINDOW = LM_ACCESSSTATE + 9     '//9229
'// End Shell Hook Messages
Public Const LM_RECYCLE = 9260
Public Const LM_REGISTERMESSAGE = 9263
Public Const LM_UNREGISTERMESSAGE = 9264
Public Const LM_GETREVID = 9265
Public Const LM_UNLOADMODULE = 9266
Public Const LM_RELOADMODULE = 9267
Public Const LM_SHADETOGGLE = 9300

'// VWM messages
Public Const LM_VWMUP = 9350
Public Const LM_VWMDOWN = 9351
Public Const LM_VWMLEFT = 9352
Public Const LM_VWMRIGHT = 9353
Public Const LM_VWMNAV = 9354
Public Const LM_SWITCHTON = 9355
Public Const LM_ISSTICKY = 9356
Public Const LM_STICK = 9357
Public Const LM_UNSTICK = 9358

'// core messages
Public Const LM_GETLSOBJECT = 9400
Public Const LM_WINDOWLIST = 9401
Public Const LM_DATASTORE = 9410
Public Const LM_MESSAGEMANAGER = 9411
Public Const LM_BANGCOMMAND = 9420

'// shell hook messages
Public Const LM_WINDOWCREATED = 9501
Public Const LM_WINDOWDESTROYED = 9502
Public Const LM_ACTIVATESHELLWINDOW = 9503
Public Const LM_WINDOWACTIVATED = 9504
Public Const LM_GETMINRECT = 9505
Public Const LM_REDRAW = 9506
Public Const LM_TASKMAN = 9507
Public Const LM_LANGUAGE = 9508
Public Const LM_ACCESSIBILITYSTATE = 9511
Public Const LM_APPCOMMAND = 9512

'// general constants
'//

Public Const MAX_BANGCOMMAND = 64
Public Const MAX_BANGARGS = 256
Public Const MAX_RCCOMMAND = 64
Public Const MAX_LINE_LENGTH = 4096
Public Const MAX_PATH_LENGTH = 1024


'//---------------------------------------------------------
'// Bang command struct
'//---------------------------------------------------------

Public Type BangCommand
    sender As Long
    args As String
End Type

Public Type BangCommandEx
    sender As Long
    args As String
    command As String
End Type

'typedef struct _LMBANGCOMMANDA
'{
'  UINT cbSize;
'  HWND hWnd;
'  CHAR szCommand[MAX_BANGCOMMAND];
'  CHAR szArgs[MAX_BANGARGS];
'} LMBANGCOMMANDA, *PLMBANGCOMMANDA;
Public Type LMBANGCOMMANDA
    cbSize As Long
    hWnd As Long
    szCommand(MAX_BANGCOMMAND) As String
    szArgs(MAX_BANGARGS) As String
End Type

'public const LMBANGCOMMAND    LMBANGCOMMANDA
'public const PLMBANGCOMMAND   PLMBANGCOMMANDA

'//---------------------------------------------------------
'// LSAPI functions
'//---------------------------------------------------------

Public Declare Sub LitestepAPIInit Lib "vblsapi.dll" Alias "VBLitestepAPIInit" ()


Public Declare Function LCOpen Lib "vblsapi.dll" Alias "VBLCOpen" (ByVal szPath As String) As Long
Public Declare Function LCClose Lib "vblsapi.dll" Alias "VBLCClose" (ByVal f As Long) As Long
Public Declare Function LCReadNextCommand Lib "vblsapi.dll" Alias "VBLCReadNextCommand" (ByVal f As Long, ByVal szBuffer As String, ByVal dwLength As Long) As Long
Public Declare Function LCReadNextConfig Lib "vblsapi.dll" Alias "VBLCReadNextConfig" (ByVal f As Long, ByVal szPrefix As String, ByVal szBuffer As String, ByVal dwLength As Long) As Long
Public Declare Function LCReadNextLine Lib "vblsapi.dll" Alias "VBLCReadNextLine" (ByVal f As Long, ByVal szBuffer As String, ByVal dwLength As Long) As Long
'Public Declare Function LCTokenize Lib "vblsapi.dll" Alias "VBLCTokenize" (ByVal szString As String, lpszBuffers As String, ByVal dwNumBuffers As Long, ByVal szExtraParameters As String) As Long
Public Declare Function SetupRC Lib "vblsapi.dll" Alias "VBSetupRC" (ByVal szPath As String) As Long
Public Declare Sub CloseRC Lib "vblsapi.dll" Alias "VBCloseRC" ()

Public Declare Function GetRCInt Lib "vblsapi.dll" Alias "VBGetRCInt" (ByVal lpKeyName As String, ByVal nDefault As Long) As Long
Public Declare Function GetRCString Lib "vblsapi.dll" Alias "VBGetRCString" (ByVal lpKeyName As String, ByVal value As String, ByVal defStr1 As String, ByVal maxLen As Long) As Long
Public Declare Function GetRCBool Lib "vblsapi.dll" Alias "VBGetRCBool" (ByVal lpKeyName As String, ByVal ifFound As Long) As Long
Public Declare Function GetRCLine Lib "vblsapi.dll" Alias "VBGetRCLine" (ByVal szKeyName As String, ByVal szBuffer As String, ByVal nBufLen As Long, ByVal szDefault As String) As Long
Public Declare Function GetRCColor Lib "vblsapi.dll" Alias "VBGetRCColor" (ByVal lpKeyName As String, ByVal colDef As Long) As Long

Public Declare Sub SetBangManager Lib "vblsapi.dll" Alias "VBSetBangManager" ()
Public Declare Sub ClearBangManager Lib "vblsapi.dll" Alias "VBClearBangManager" ()
Public Declare Function AddBangCommand Lib "vblsapi.dll" Alias "VBAddBangCommand" (ByVal command As String, f As BangCommand) As Long
Public Declare Function AddBangCommandEx Lib "vblsapi.dll" Alias "VBAddBangCommandEx" (ByVal command As String, f As BangCommandEx) As Long
Public Declare Function RemoveBangCommand Lib "vblsapi.dll" Alias "VBRemoveBangCommand" (ByVal command As String) As Long
Public Declare Function ParseBangCommand Lib "vblsapi.dll" Alias "VBParseBangCommand" (ByVal caller As Long, ByVal command As String, ByVal args As String) As Long

Public Declare Function BitmapToRegion Lib "vblsapi.dll" Alias "VBBitmapToRegion" (ByVal hBmp As Long, ByVal cTransparentColor As Long, ByVal cTolerance As Long, ByVal xoffset As Long, ByVal yoffset As Long) As Long
Public Declare Function BitmapFromIcon Lib "vblsapi.dll" Alias "VBBitmapFromIcon" (ByVal hIcon As Long) As Long
Public Declare Function LoadLSImage Lib "vblsapi.dll" Alias "VBLoadLSImage" (ByVal szFile As String, ByVal szImage As String) As Long
Public Declare Function LoadLSIcon Lib "vblsapi.dll" Alias "VBLoadLSIcon" (ByVal szImage As String, ByVal szFile As String) As Long
Public Declare Sub GetBitmapSize Lib "vblsapi.dll" Alias "VBGetBitmapSize" (ByVal hBitmap As Long, ByVal x As Long, ByVal y As Long)
Public Declare Sub TransparentBltLS Lib "vblsapi.dll" (ByVal dc As Long, ByVal nXDest As Long, ByVal nYDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal tempDC As Long, ByVal nXSrc As Long, ByVal nYSrc As Long, ByVal colorTransparent As Long)

Public Declare Function CommandTokenize Lib "vblsapi.dll" Alias "VBCommandTokenize" (ByVal szString As String, lpszBuffers As Any, ByVal dwNumBuffers As Long, ByVal szExtraParameters As String) As Long
Public Declare Sub CommandParse Lib "vblsapi.dll" Alias "VBCommandParse" (ByVal cmd As String, ByVal cmdbuf As String, ByVal argsbuf As String, ByVal dwCmdBufSize As Long, ByVal dwArgsBufSize As Long)

Public Declare Function LSExecute Lib "vblsapi.dll" Alias "VBLSExecute" (ByVal Owner As Long, ByVal szCommand As String, ByVal nShowCmd As Long) As Long
Public Declare Function LSExecuteEx Lib "vblsapi.dll" Alias "VBLSExecuteEx" (ByVal Owner As Long, ByVal szOperation As String, ByVal szCommand As String, ByVal szArgs As String, ByVal szDirectory As String, ByVal nShowCmd As Long) As Long

Public Declare Function GetLitestepWnd Lib "vblsapi.dll" Alias "VBGetLitestepWnd" () As Long
Public Declare Function LSGetLitestepPath Lib "vblsapi.dll" Alias "VBLSGetLitestepPath" (ByVal pszPath As String, ByVal nMaxLen As Long) As Integer
Public Declare Function LSGetImagePath Lib "vblsapi.dll" Alias "VBLSGetImagePath" (ByVal pszPath As String, ByVal nMaxLen As Long) As Long
Public Declare Sub VarExpansion Lib "vblsapi.dll" Alias "VBVarExpansion" (ByVal Buffer As String, ByVal value As String)
Public Declare Function GetToken Lib "vblsapi.dll" Alias "VBGetToken" (ByVal szString As String, ByVal szToken As String, ByVal szNextToken As String, ByVal useBrackets As Long) As Long
Public Declare Sub Frame3D Lib "vblsapi.dll" Alias "VBFrame3D" (ByVal dc As Long, RECT As RECT, ByVal TopColor As Long, ByVal BottomColor As Long, ByVal Width As Long)
Public Declare Sub SetDesktopArea Lib "vblsapi.dll" Alias "VBSetDesktopArea" (ByVal Left As Long, ByVal Top As Long, ByVal Right As Long, ByVal Bottom As Long)

Public Declare Function match Lib "vblsapi.dll" Alias "VBmatch" (ByVal pattern As String, ByVal text As String) As Long
Public Declare Function matche Lib "vblsapi.dll" Alias "VBmatche" (ByVal pattern As String, ByVal text As String) As Long
Public Declare Function is_valid_pattern Lib "vblsapi.dll" Alias "VBis_valid_pattern" (ByVal pattern As String, ByVal error_type As Long) As Long

Public Declare Sub setupVars Lib "vblsapi.dll" Alias "VBsetupVars" (ByVal szLSPath As String)
Public Declare Sub setupBangs Lib "vblsapi.dll" Alias "VBsetupBangs" ()

'* End lsapi.h
'***************************************

Public Function LCTokenize(ByVal szString As String, ByRef lpszBuffers() As String) As Long
    Dim DStart As Integer, Element As Integer, DStop As Integer
    DStart = 1
    ReDim lpszBuffers(0) As String
    
    Element = 0
    
    Do
        DStop = InStr(DStart, szString, " ")
        
        'If DStop > InStr(DStart, szString, Chr$(34)) Then DStop = InStr(DStart, szString, Chr$(34))
        
        If DStop > 0 Then
            ReDim Preserve lpszBuffers(Element)
            lpszBuffers(Element) = Mid$(szString, DStart, DStop - DStart)
            DStart = DStop + 1
        Else
            DStop = Len(szString)
            ReDim Preserve lpszBuffers(Element)
            lpszBuffers(Element) = Mid$(szString, DStart, DStop - DStart + 1)
        End If
        DStart = DStop + 1
        Element = Element + 1
    Loop Until DStart > Len(szString)
    LCTokenize = Element
End Function

Public Sub RemoveNull(ByRef szString As String)
    szString = Trim(szString)
    If Right(szString, 1) = Chr$(0) Then
        szString = Left(szString, Len(szString) - 1)
    End If
End Sub
